"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => solidLabelsPlugin
});
module.exports = __toCommonJS(src_exports);

// src/components.ts
var t = __toESM(require("@babel/types"), 1);

// src/core/get-import-identifier.ts
var import_helper_module_imports = require("@babel/helper-module-imports");
function getImportIdentifier(state, path, name, source) {
  const id = `${source}[${name}]`;
  const current = state.hooks.get(id);
  if (current) {
    return current;
  }
  const newID = (0, import_helper_module_imports.addNamed)(path, name, source);
  state.hooks.set(id, newID);
  return newID;
}

// src/components.ts
var COMPONENTS = {
  // Components
  For: ["For", "solid-js"],
  Show: ["Show", "solid-js"],
  Switch: ["Switch", "solid-js"],
  Match: ["Match", "solid-js"],
  Index: ["Index", "solid-js"],
  ErrorBoundary: ["ErrorBoundary", "solid-js"],
  Suspense: ["Suspense", "solid-js"],
  SuspenseList: ["SuspenseList", "solid-js"],
  Dynamic: ["Dynamic", "solid-js/web"],
  Portal: ["Portal", "solid-js/web"],
  Assets: ["Assets", "solid-js/web"],
  HydrationScript: ["HydrationScript", "solid-js/web"],
  NoHydration: ["NoHydration", "solid-js/web"]
};
var NAMESPACE = "solid";
var NAMESPACE_COMPONENTS = {
  // Components
  for: ["For", "solid-js"],
  show: ["Show", "solid-js"],
  switch: ["Switch", "solid-js"],
  match: ["Match", "solid-js"],
  index: ["Index", "solid-js"],
  "error-boundary": ["ErrorBoundary", "solid-js"],
  suspense: ["Suspense", "solid-js"],
  "suspense-list": ["SuspenseList", "solid-js"],
  dynamic: ["Dynamic", "solid-js/web"],
  portal: ["Portal", "solid-js/web"],
  assets: ["Assets", "solid-js/web"],
  "hydration-script": ["HydrationScript", "solid-js/web"],
  "no-hydration": ["NoHydration", "solid-js/web"]
};
function transformComponents(state, path) {
  path.traverse({
    Expression(p) {
      if (t.isIdentifier(p.node) && !p.scope.hasBinding(p.node.name) && p.node.name in COMPONENTS) {
        const [name, source] = COMPONENTS[p.node.name];
        p.replaceWith(getImportIdentifier(state, p, name, source));
      }
    },
    JSXElement(p) {
      const { openingElement, closingElement } = p.node;
      const id = openingElement.name;
      let replacement;
      if (t.isJSXNamespacedName(id) && id.namespace.name === NAMESPACE && id.name.name in NAMESPACE_COMPONENTS) {
        const [name, source] = NAMESPACE_COMPONENTS[id.name.name];
        const identifier8 = getImportIdentifier(state, p, name, source);
        replacement = t.jsxIdentifier(identifier8.name);
      }
      if (t.isJSXIdentifier(id) && !p.scope.hasBinding(id.name) && id.name in COMPONENTS) {
        const [name, source] = COMPONENTS[id.name];
        const identifier8 = getImportIdentifier(state, p, name, source);
        replacement = t.jsxIdentifier(identifier8.name);
      }
      if (replacement) {
        openingElement.name = replacement;
        if (closingElement) {
          closingElement.name = replacement;
        }
      }
    }
  });
}

// src/transform-ctf.ts
var t15 = __toESM(require("@babel/types"), 1);

// src/core/deref-signal-variable.ts
var t6 = __toESM(require("@babel/types"), 1);

// src/core/deref-signal.ts
var t5 = __toESM(require("@babel/types"), 1);

// src/core/assert.ts
function assert(cond, error) {
  if (!cond) {
    throw error;
  }
}

// src/core/errors.ts
function unexpectedType(path, received, expected) {
  return path.buildCodeFrameError(`Unexpected '${received}' (Expected: ${expected})`);
}
function unexpectedArgumentLength(path, received, expected) {
  return path.buildCodeFrameError(`Unexpected argument length of ${received} (Expected: ${expected})`);
}

// src/core/is-awaited.ts
var t2 = __toESM(require("@babel/types"), 1);

// src/core/arrays.ts
function forEach(arr, callback) {
  for (let i = 0, len = arr.length; i < len; i += 1) {
    if (callback(arr[i], i)) {
      break;
    }
  }
}
function some(arr, callback) {
  for (let i = 0, len = arr.length; i < len; i += 1) {
    if (callback(arr[i], i)) {
      return true;
    }
  }
  return false;
}
function every(arr, callback) {
  for (let i = 0, len = arr.length; i < len; i += 1) {
    if (!callback(arr[i], i)) {
      return false;
    }
  }
  return true;
}

// src/core/is-awaited.ts
function isAwaited(node) {
  if (t2.isAwaitExpression(node)) {
    return true;
  }
  if (t2.isTemplateLiteral(node)) {
    return some(node.expressions, (expr) => t2.isExpression(expr) && isAwaited(expr));
  }
  if (t2.isLiteral(node) || t2.isIdentifier(node) || t2.isArrowFunctionExpression(node) || t2.isFunctionExpression(node) || t2.isClassExpression(node) || t2.isYieldExpression(node) || t2.isJSX(node) || t2.isMetaProperty(node) || t2.isSuper(node) || t2.isThisExpression(node) || t2.isImport(node) || t2.isDoExpression(node)) {
    return false;
  }
  if (t2.isTaggedTemplateExpression(node)) {
    return isAwaited(node.tag) || isAwaited(node.quasi);
  }
  if (t2.isUnaryExpression(node) || t2.isUpdateExpression(node) || t2.isSpreadElement(node)) {
    return isAwaited(node.argument);
  }
  if (t2.isParenthesizedExpression(node) || t2.isTypeCastExpression(node) || t2.isTSAsExpression(node) || t2.isTSSatisfiesExpression(node) || t2.isTSNonNullExpression(node) || t2.isTSTypeAssertion(node) || t2.isTSInstantiationExpression(node)) {
    return isAwaited(node.expression);
  }
  if (t2.isArrayExpression(node) || t2.isTupleExpression(node)) {
    return some(node.elements, (el) => el != null && isAwaited(el));
  }
  if (t2.isAssignmentExpression(node)) {
    if (isAwaited(node.right)) {
      return true;
    }
    if (t2.isExpression(node.left)) {
      return isAwaited(node.left);
    }
    return false;
  }
  if (t2.isBinaryExpression(node)) {
    if (t2.isExpression(node.left) && isAwaited(node.left)) {
      return true;
    }
    return isAwaited(node.right);
  }
  if (t2.isCallExpression(node) || t2.isOptionalCallExpression(node) || t2.isNewExpression(node)) {
    if (t2.isExpression(node.callee) && isAwaited(node.callee)) {
      return true;
    }
    return some(node.arguments, (arg) => arg && (t2.isSpreadElement(arg) || t2.isExpression(arg)) && isAwaited(arg));
  }
  if (t2.isConditionalExpression(node)) {
    return isAwaited(node.test) || isAwaited(node.consequent) || isAwaited(node.alternate);
  }
  if (t2.isLogicalExpression(node)) {
    return isAwaited(node.left) || isAwaited(node.right);
  }
  if (t2.isMemberExpression(node) || t2.isOptionalMemberExpression(node)) {
    return isAwaited(node.object) || node.computed && t2.isExpression(node.property) && isAwaited(node.property);
  }
  if (t2.isSequenceExpression(node)) {
    return some(node.expressions, isAwaited);
  }
  if (t2.isObjectExpression(node) || t2.isRecordExpression(node)) {
    return some(node.properties, (prop) => {
      if (t2.isObjectProperty(prop)) {
        if (t2.isExpression(prop.value) && isAwaited(prop.value)) {
          return true;
        }
        if (prop.computed && t2.isExpression(prop.key) && isAwaited(prop.key)) {
          return true;
        }
        return false;
      }
      if (t2.isSpreadElement(prop)) {
        return isAwaited(prop);
      }
      return false;
    });
  }
  if (t2.isBindExpression(node)) {
    return isAwaited(node.object) || isAwaited(node.callee);
  }
  return false;
}

// src/core/is-yielded.ts
var t3 = __toESM(require("@babel/types"), 1);
function isYielded(node) {
  if (t3.isYieldExpression(node)) {
    return true;
  }
  if (t3.isTemplateLiteral(node)) {
    return some(node.expressions, (expr) => t3.isExpression(expr) && isYielded(expr));
  }
  if (t3.isLiteral(node) || t3.isIdentifier(node) || t3.isArrowFunctionExpression(node) || t3.isFunctionExpression(node) || t3.isClassExpression(node) || t3.isYieldExpression(node) || t3.isJSX(node) || t3.isMetaProperty(node) || t3.isSuper(node) || t3.isThisExpression(node) || t3.isImport(node) || t3.isDoExpression(node)) {
    return false;
  }
  if (t3.isTaggedTemplateExpression(node)) {
    return isYielded(node.tag) || isYielded(node.quasi);
  }
  if (t3.isUnaryExpression(node) || t3.isUpdateExpression(node) || t3.isSpreadElement(node)) {
    return isYielded(node.argument);
  }
  if (t3.isParenthesizedExpression(node) || t3.isTypeCastExpression(node) || t3.isTSAsExpression(node) || t3.isTSSatisfiesExpression(node) || t3.isTSNonNullExpression(node) || t3.isTSTypeAssertion(node) || t3.isTSInstantiationExpression(node)) {
    return isYielded(node.expression);
  }
  if (t3.isArrayExpression(node) || t3.isTupleExpression(node)) {
    return some(node.elements, (el) => el != null && isYielded(el));
  }
  if (t3.isAssignmentExpression(node)) {
    if (isYielded(node.right)) {
      return true;
    }
    if (t3.isExpression(node.left)) {
      return isYielded(node.left);
    }
    return false;
  }
  if (t3.isBinaryExpression(node)) {
    if (t3.isExpression(node.left) && isYielded(node.left)) {
      return true;
    }
    return isYielded(node.right);
  }
  if (t3.isCallExpression(node) || t3.isOptionalCallExpression(node) || t3.isNewExpression(node)) {
    if (t3.isExpression(node.callee) && isYielded(node.callee)) {
      return true;
    }
    return some(node.arguments, (arg) => arg && (t3.isSpreadElement(arg) || t3.isExpression(arg)) && isYielded(arg));
  }
  if (t3.isConditionalExpression(node)) {
    return isYielded(node.test) || isYielded(node.consequent) || isYielded(node.alternate);
  }
  if (t3.isLogicalExpression(node)) {
    return isYielded(node.left) || isYielded(node.right);
  }
  if (t3.isMemberExpression(node) || t3.isOptionalMemberExpression(node)) {
    return isYielded(node.object) || node.computed && t3.isExpression(node.property) && isYielded(node.property);
  }
  if (t3.isSequenceExpression(node)) {
    return some(node.expressions, isYielded);
  }
  if (t3.isObjectExpression(node) || t3.isRecordExpression(node)) {
    return some(node.properties, (prop) => {
      if (t3.isObjectProperty(prop)) {
        if (t3.isExpression(prop.value) && isYielded(prop.value)) {
          return true;
        }
        if (prop.computed && t3.isExpression(prop.key) && isYielded(prop.key)) {
          return true;
        }
        return false;
      }
      if (t3.isSpreadElement(prop)) {
        return isYielded(prop);
      }
      return false;
    });
  }
  if (t3.isBindExpression(node)) {
    return isYielded(node.object) || isYielded(node.callee);
  }
  return false;
}

// src/core/unwrap-node.ts
var t4 = __toESM(require("@babel/types"), 1);
function unwrapNode(node, key) {
  if (key(node)) {
    return node;
  }
  if (t4.isParenthesizedExpression(node) || t4.isTypeCastExpression(node) || t4.isTSAsExpression(node) || t4.isTSSatisfiesExpression(node) || t4.isTSNonNullExpression(node) || t4.isTSTypeAssertion(node) || t4.isTSInstantiationExpression(node)) {
    return unwrapNode(node.expression, key);
  }
  return void 0;
}

// src/core/deref-signal.ts
var REF_SIGNAL_CTF = "$refSignal";
var GET_CTF = "$get";
var SET_CTF = "$set";
var CALL_CTF = /* @__PURE__ */ new Set([REF_SIGNAL_CTF, GET_CTF, SET_CTF]);
var GETTER_CTF = "$getter";
var SETTER_CTF = "$setter";
var PROPERTY_CTF = "$property";
var OBJECT_PROPERTY_CTF = /* @__PURE__ */ new Set([GETTER_CTF, SETTER_CTF, PROPERTY_CTF]);
function derefSignal(path, signalIdentifier, readIdentifier, writeIdentifier) {
  path.scope.path.traverse({
    CallExpression(p) {
      if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
        return;
      }
      const trueCallee = unwrapNode(p.node.callee, t5.isIdentifier);
      if (!trueCallee || p.scope.hasBinding(trueCallee.name) || !CALL_CTF.has(trueCallee.name)) {
        return;
      }
      const rawArgs = p.node.arguments[0];
      const arg = unwrapNode(rawArgs, t5.isIdentifier);
      assert(arg, unexpectedType(p, rawArgs.type, "Identifier"));
      if (arg.name !== signalIdentifier.name) {
        return;
      }
      if (trueCallee.name === REF_SIGNAL_CTF) {
        p.replaceWith(
          t5.arrayExpression([
            readIdentifier,
            writeIdentifier
          ])
        );
      }
      if (trueCallee.name === GET_CTF) {
        p.replaceWith(readIdentifier);
      }
      if (trueCallee.name === SET_CTF) {
        p.replaceWith(writeIdentifier);
      }
    },
    ObjectProperty(p) {
      if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
        return;
      }
      if (p.node.shorthand && !p.node.computed) {
        if (t5.isIdentifier(p.node.key) && t5.isIdentifier(p.node.value) && p.node.key.name === signalIdentifier.name && p.node.value.name === signalIdentifier.name) {
          p.replaceWith(
            t5.objectProperty(
              p.node.key,
              t5.callExpression(readIdentifier, [])
            )
          );
        }
        return;
      }
      const trueCallExpr = unwrapNode(p.node.value, t5.isCallExpression);
      if (trueCallExpr) {
        const trueCallee = unwrapNode(trueCallExpr.callee, t5.isIdentifier);
        if (!trueCallee || p.scope.hasBinding(trueCallee.name) || !OBJECT_PROPERTY_CTF.has(trueCallee.name)) {
          return;
        }
        assert(!t5.isPrivateName(p.node.key), unexpectedType(p, "PrivateName", "Expression"));
        const arg = trueCallExpr.arguments[0];
        assert(t5.isIdentifier(arg), unexpectedType(p, arg.type, "Identifier"));
        if (arg.name !== signalIdentifier.name) {
          return;
        }
        if (trueCallee.name === SETTER_CTF) {
          const param = p.scope.generateUidIdentifier("value");
          p.replaceWith(
            t5.objectMethod(
              "set",
              p.node.key,
              [param],
              t5.blockStatement([
                t5.returnStatement(
                  t5.callExpression(
                    writeIdentifier,
                    [
                      t5.arrowFunctionExpression(
                        [],
                        param
                      )
                    ]
                  )
                )
              ])
            )
          );
        }
        if (trueCallee.name === GETTER_CTF) {
          p.replaceWith(
            t5.objectMethod(
              "get",
              p.node.key,
              [],
              t5.blockStatement([
                t5.returnStatement(
                  t5.callExpression(
                    readIdentifier,
                    []
                  )
                )
              ])
            )
          );
        }
        if (trueCallee.name === PROPERTY_CTF) {
          const param = p.scope.generateUidIdentifier("value");
          p.replaceWithMultiple([
            t5.objectMethod(
              "get",
              p.node.key,
              [],
              t5.blockStatement([
                t5.returnStatement(
                  t5.callExpression(
                    readIdentifier,
                    []
                  )
                )
              ])
            ),
            t5.objectMethod(
              "set",
              p.node.key,
              [param],
              t5.blockStatement([
                t5.returnStatement(
                  t5.callExpression(
                    writeIdentifier,
                    [
                      t5.arrowFunctionExpression(
                        [],
                        param
                      )
                    ]
                  )
                )
              ])
            )
          ]);
        }
      }
    },
    Expression(p) {
      if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
        return;
      }
      if (t5.isIdentifier(p.node) && p.node.name === signalIdentifier.name) {
        p.replaceWith(t5.callExpression(readIdentifier, []));
      }
    },
    UpdateExpression(p) {
      if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
        return;
      }
      if (t5.isIdentifier(p.node.argument) && p.node.argument.name === signalIdentifier.name) {
        const param = p.scope.generateUidIdentifier("current");
        if (p.node.prefix) {
          p.replaceWith(
            t5.callExpression(
              writeIdentifier,
              [
                t5.arrowFunctionExpression(
                  [param],
                  t5.binaryExpression(
                    p.node.operator === "++" ? "+" : "-",
                    param,
                    t5.numericLiteral(1)
                  )
                )
              ]
            )
          );
        } else {
          p.replaceWith(
            t5.callExpression(
              t5.arrowFunctionExpression(
                [],
                t5.blockStatement([
                  t5.variableDeclaration(
                    "const",
                    [
                      t5.variableDeclarator(
                        param,
                        t5.callExpression(
                          readIdentifier,
                          []
                        )
                      )
                    ]
                  ),
                  t5.expressionStatement(
                    t5.callExpression(
                      writeIdentifier,
                      [
                        t5.arrowFunctionExpression(
                          [],
                          t5.binaryExpression(
                            p.node.operator === "++" ? "+" : "-",
                            param,
                            t5.numericLiteral(1)
                          )
                        )
                      ]
                    )
                  ),
                  t5.returnStatement(
                    param
                  )
                ])
              ),
              []
            )
          );
        }
      }
    },
    AssignmentExpression(p) {
      if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
        return;
      }
      const identifier8 = p.node.left;
      let expression = p.node.right;
      if (isAwaited(expression) || isYielded(expression)) {
        const statement = p.getStatementParent();
        const functionParent = p.getFunctionParent();
        if (statement) {
          const awaitedID = statement.scope.generateUidIdentifier("tmp");
          const declaration = t5.variableDeclaration(
            "const",
            [t5.variableDeclarator(
              awaitedID,
              expression
            )]
          );
          if (functionParent) {
            if (functionParent.isAncestor(statement)) {
              statement.insertBefore(declaration);
            } else {
              functionParent.scope.push({
                id: awaitedID,
                init: expression,
                kind: "const"
              });
            }
          } else {
            statement.insertBefore(declaration);
          }
          expression = awaitedID;
        }
      }
      if (t5.isIdentifier(identifier8) && identifier8.name === signalIdentifier.name) {
        let arg;
        if (p.node.operator === "=") {
          arg = t5.arrowFunctionExpression([], expression);
        } else {
          const param = p.scope.generateUidIdentifier("current");
          arg = t5.arrowFunctionExpression(
            [param],
            t5.assignmentExpression(
              p.node.operator,
              param,
              expression
            )
          );
        }
        p.replaceWith(t5.callExpression(writeIdentifier, [arg]));
      }
    }
  });
}

// src/core/deref-signal-variable.ts
function derefSignalVariable(path, signalIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  derefSignal(
    path,
    signalIdentifier,
    readIdentifier,
    writeIdentifier
  );
  return t6.variableDeclarator(
    t6.arrayPattern([
      readIdentifier,
      writeIdentifier
    ]),
    stateIdentifier
  );
}

// src/core/accessor-variable.ts
var t8 = __toESM(require("@babel/types"), 1);

// src/core/deref-memo.ts
var t7 = __toESM(require("@babel/types"), 1);
var REF_MEMO_CTF = "$refMemo";
var GET_CTF2 = "$get";
var CALL_CTF2 = /* @__PURE__ */ new Set([REF_MEMO_CTF, GET_CTF2]);
var GETTER_CTF2 = "$getter";
var PROPERTY_CTF2 = "$property";
var OBJECT_PROPERTY_CTF2 = /* @__PURE__ */ new Set([GETTER_CTF2, PROPERTY_CTF2]);
function derefMemo(path, memoIdentifier, readIdentifier) {
  path.scope.path.traverse({
    CallExpression(p) {
      if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
        return;
      }
      const trueCallee = unwrapNode(p.node.callee, t7.isIdentifier);
      if (!trueCallee || p.scope.hasBinding(trueCallee.name) || !CALL_CTF2.has(trueCallee.name)) {
        return;
      }
      const rawArgs = p.node.arguments[0];
      const arg = unwrapNode(rawArgs, t7.isIdentifier);
      assert(arg, unexpectedType(p, rawArgs.type, "Identifier"));
      if (arg.name !== memoIdentifier.name) {
        return;
      }
      if (trueCallee.name === REF_MEMO_CTF) {
        p.replaceWith(readIdentifier);
      }
      if (trueCallee.name === GET_CTF2) {
        p.replaceWith(readIdentifier);
      }
    },
    ObjectProperty(p) {
      if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
        return;
      }
      if (p.node.shorthand && !p.node.computed) {
        if (t7.isIdentifier(p.node.key) && t7.isIdentifier(p.node.value) && p.node.key.name === memoIdentifier.name && p.node.value.name === memoIdentifier.name) {
          p.replaceWith(
            t7.objectProperty(
              p.node.key,
              t7.callExpression(readIdentifier, [])
            )
          );
        }
        return;
      }
      const trueCallExpr = unwrapNode(p.node.value, t7.isCallExpression);
      if (trueCallExpr) {
        const trueCallee = unwrapNode(trueCallExpr.callee, t7.isIdentifier);
        if (!trueCallee || p.scope.hasBinding(trueCallee.name) || !OBJECT_PROPERTY_CTF2.has(trueCallee.name)) {
          return;
        }
        assert(!t7.isPrivateName(p.node.key), unexpectedType(p, "PrivateName", "Expression"));
        const arg = trueCallExpr.arguments[0];
        assert(t7.isIdentifier(arg), unexpectedType(p, arg.type, "Identifier"));
        if (arg.name !== memoIdentifier.name) {
          return;
        }
        if (trueCallee.name === GETTER_CTF2) {
          p.replaceWith(
            t7.objectMethod(
              "get",
              p.node.key,
              [],
              t7.blockStatement([
                t7.returnStatement(
                  t7.callExpression(
                    readIdentifier,
                    []
                  )
                )
              ])
            )
          );
        }
        if (trueCallee.name === PROPERTY_CTF2) {
          p.replaceWith(
            t7.objectMethod(
              "get",
              p.node.key,
              [],
              t7.blockStatement([
                t7.returnStatement(
                  t7.callExpression(
                    readIdentifier,
                    []
                  )
                )
              ])
            )
          );
        }
      }
    },
    Expression(p) {
      if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
        return;
      }
      if (t7.isIdentifier(p.node) && p.node.name === memoIdentifier.name) {
        p.replaceWith(t7.callExpression(readIdentifier, []));
      }
    }
  });
}

// src/core/accessor-variable.ts
function accessorVariable(path, accessorIdentifier, callee, replacement) {
  const readIdentifier = path.scope.generateUidIdentifier(accessorIdentifier.name);
  derefMemo(
    path,
    accessorIdentifier,
    readIdentifier
  );
  return t8.variableDeclarator(
    readIdentifier,
    t8.callExpression(callee, replacement)
  );
}

// src/core/deferred-variable.ts
var t9 = __toESM(require("@babel/types"), 1);
function deferredVariable(state, path, deferredIdentifier, stateIdentifier = t9.identifier("undefined"), optionsIdentifier = void 0) {
  const normalIdentifier = t9.arrowFunctionExpression([], stateIdentifier);
  const args = [normalIdentifier];
  if (state.opts.dev) {
    if (optionsIdentifier) {
      args.push(t9.callExpression(
        t9.memberExpression(
          t9.identifier("Object"),
          t9.identifier("assign")
        ),
        [
          t9.objectExpression([
            t9.objectProperty(
              t9.identifier("name"),
              t9.stringLiteral(deferredIdentifier.name)
            )
          ]),
          optionsIdentifier
        ]
      ));
    } else {
      args.push(t9.objectExpression([
        t9.objectProperty(
          t9.identifier("name"),
          t9.stringLiteral(deferredIdentifier.name)
        )
      ]));
    }
  } else if (optionsIdentifier) {
    args.push(optionsIdentifier);
  }
  return accessorVariable(
    path,
    deferredIdentifier,
    getImportIdentifier(state, path, "createDeferred", "solid-js"),
    args
  );
}

// src/core/deref-memo-variable.ts
var t10 = __toESM(require("@babel/types"), 1);
function derefMemoVariable(path, memoIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(memoIdentifier.name);
  derefMemo(
    path,
    memoIdentifier,
    readIdentifier
  );
  return t10.variableDeclarator(readIdentifier, stateIdentifier);
}

// src/core/destructure-variable.ts
var t12 = __toESM(require("@babel/types"), 1);

// src/core/is-static.ts
var t11 = __toESM(require("@babel/types"), 1);
function isStatic(node) {
  if (t11.isParenthesizedExpression(node) || t11.isTypeCastExpression(node) || t11.isTSAsExpression(node) || t11.isTSSatisfiesExpression(node) || t11.isTSNonNullExpression(node) || t11.isTSTypeAssertion(node) || t11.isTSInstantiationExpression(node)) {
    return isStatic(node.expression);
  }
  if (t11.isUnaryExpression(node) || t11.isUpdateExpression(node) || t11.isSpreadElement(node)) {
    return isStatic(node.argument);
  }
  if (t11.isRestElement(node)) {
    if (t11.isTSParameterProperty(node.argument)) {
      return false;
    }
    return isStatic(node.argument);
  }
  if (t11.isLiteral(node)) {
    if (t11.isTemplateLiteral(node)) {
      return every(node.expressions, (expr) => {
        if (t11.isExpression(expr)) {
          return isStatic(expr);
        }
        return false;
      });
    }
    return true;
  }
  if (t11.isIdentifier(node) || t11.isArrowFunctionExpression(node) || t11.isFunctionExpression(node) || t11.isJSXElement(node) || t11.isJSXFragment(node)) {
    return true;
  }
  if (t11.isArrayExpression(node) || t11.isTupleExpression(node)) {
    return every(node.elements, (el) => {
      if (el) {
        return isStatic(el);
      }
      return true;
    });
  }
  if (t11.isArrayPattern(node)) {
    return every(node.elements, (el) => {
      if (t11.isTSParameterProperty(el)) {
        return false;
      }
      if (el) {
        return isStatic(el);
      }
      return true;
    });
  }
  if (t11.isObjectExpression(node) || t11.isRecordExpression(node)) {
    return every(node.properties, (prop) => {
      if (t11.isObjectProperty(prop)) {
        if (t11.isExpression(prop.value) && isStatic(prop.value)) {
          return true;
        }
        if (prop.computed && t11.isExpression(prop.key) && isStatic(prop.key)) {
          return true;
        }
        return false;
      }
      if (t11.isSpreadElement(prop)) {
        return isStatic(prop);
      }
      return true;
    });
  }
  if (t11.isObjectPattern(node)) {
    return every(node.properties, (prop) => {
      if (t11.isObjectProperty(prop)) {
        if (!t11.isTSTypeParameter(prop.value) && isStatic(prop.value)) {
          return true;
        }
        if (prop.computed && t11.isExpression(prop.key) && isStatic(prop.key)) {
          return true;
        }
        return false;
      }
      if (t11.isSpreadElement(prop)) {
        return isStatic(prop);
      }
      return true;
    });
  }
  if (t11.isAssignmentExpression(node) || t11.isAssignmentPattern(node)) {
    if (isStatic(node.right)) {
      return true;
    }
    if (!t11.isTSParameterProperty(node.left)) {
      return false;
    }
    return isStatic(node);
  }
  if (t11.isSequenceExpression(node)) {
    return every(node.expressions, isStatic);
  }
  if (t11.isConditionalExpression(node)) {
    return isStatic(node.test) || isStatic(node.consequent) || isStatic(node.alternate);
  }
  if (t11.isBinaryExpression(node)) {
    if (t11.isExpression(node.left)) {
      return isStatic(node.left);
    }
    if (t11.isExpression(node.right)) {
      return isStatic(node.right);
    }
    return false;
  }
  if (t11.isLogicalExpression(node)) {
    return isStatic(node.left) || isStatic(node.right);
  }
  return false;
}

// src/core/destructure-variable.ts
function destructureVariable(state, path, target, pattern, defaultValue) {
  const otherIdentifier = path.scope.generateUidIdentifier("other");
  let declarators = [];
  const properties = [];
  let restIdentifier;
  if (t12.isObjectPattern(pattern)) {
    forEach(pattern.properties, (property) => {
      if (t12.isObjectProperty(property)) {
        const { value, key } = property;
        if (!property.computed) {
          if (t12.isIdentifier(key)) {
            properties.push(t12.stringLiteral(key.name));
          }
        } else if (t12.isPrivateName(key)) {
          throw unexpectedType(path, "PrivateName", "Expression");
        } else {
          properties.push(key);
        }
        const newIdentifier = path.scope.generateUidIdentifier("prop");
        let access = t12.memberExpression(
          target,
          key,
          property.computed
        );
        let defaultIdentifier;
        if (t12.isAssignmentPattern(value)) {
          defaultIdentifier = path.scope.generateUidIdentifier("def");
          const isStaticValue = isStatic(value.right);
          const defValue = isStaticValue ? value.right : t12.callExpression(
            getImportIdentifier(state, path, "createMemo", "solid-js"),
            [t12.arrowFunctionExpression([], value.right)]
          );
          declarators.push(
            t12.variableDeclarator(
              defaultIdentifier,
              defValue
            )
          );
          const valueIdentifier = path.scope.generateUidIdentifier("value");
          access = t12.blockStatement([
            t12.variableDeclaration(
              "const",
              [
                t12.variableDeclarator(
                  valueIdentifier,
                  access
                )
              ]
            ),
            t12.returnStatement(
              t12.conditionalExpression(
                t12.binaryExpression(
                  "===",
                  valueIdentifier,
                  t12.identifier("undefined")
                ),
                isStaticValue ? defaultIdentifier : t12.callExpression(defaultIdentifier, []),
                valueIdentifier
              )
            )
          ]);
        }
        declarators.push(
          t12.variableDeclarator(
            newIdentifier,
            t12.arrowFunctionExpression(
              [],
              access
            )
          )
        );
        if (t12.isObjectPattern(value) || t12.isArrayPattern(value)) {
          declarators = [...declarators, ...destructureVariable(
            state,
            path,
            t12.callExpression(newIdentifier, []),
            value
          )];
        } else if (t12.isIdentifier(value)) {
          derefMemo(
            path,
            value,
            newIdentifier
          );
        } else if (t12.isAssignmentPattern(value)) {
          if (t12.isIdentifier(value.left)) {
            derefMemo(
              path,
              value.left,
              newIdentifier
            );
          } else if (t12.isArrayPattern(value.left) || t12.isObjectPattern(value.left)) {
            declarators = [...declarators, ...destructureVariable(
              state,
              path,
              t12.callExpression(newIdentifier, []),
              value.left,
              defaultIdentifier
            )];
          }
        } else {
          throw unexpectedType(path, value.type, "Identifier | ObjectPattern | ArrayPattern");
        }
      } else {
        const trueIdentifier = unwrapNode(property.argument, t12.isIdentifier);
        if (trueIdentifier) {
          restIdentifier = trueIdentifier;
        }
      }
    });
  } else {
    forEach(pattern.elements, (property, i) => {
      if (property) {
        const keyExpr = t12.numericLiteral(i);
        const newIdentifier = path.scope.generateUidIdentifier("prop");
        let access = t12.memberExpression(
          target,
          keyExpr,
          true
        );
        let defaultIdentifier;
        if (t12.isAssignmentPattern(property)) {
          defaultIdentifier = path.scope.generateUidIdentifier("def");
          const isStaticValue = isStatic(property.right);
          const defValue = isStaticValue ? property.right : t12.callExpression(
            getImportIdentifier(state, path, "createMemo", "solid-js"),
            [t12.arrowFunctionExpression([], property.right)]
          );
          declarators.push(
            t12.variableDeclarator(
              defaultIdentifier,
              defValue
            )
          );
          const valueIdentifier = path.scope.generateUidIdentifier("value");
          access = t12.blockStatement([
            t12.variableDeclaration(
              "const",
              [
                t12.variableDeclarator(
                  valueIdentifier,
                  access
                )
              ]
            ),
            t12.returnStatement(
              t12.conditionalExpression(
                t12.binaryExpression(
                  "===",
                  valueIdentifier,
                  t12.identifier("undefined")
                ),
                isStaticValue ? defaultIdentifier : t12.callExpression(defaultIdentifier, []),
                valueIdentifier
              )
            )
          ]);
        }
        declarators.push(
          t12.variableDeclarator(
            newIdentifier,
            t12.arrowFunctionExpression(
              [],
              access
            )
          )
        );
        properties.push(keyExpr);
        if (t12.isIdentifier(property)) {
          derefMemo(
            path,
            property,
            newIdentifier
          );
        } else if (t12.isAssignmentPattern(property)) {
          if (t12.isIdentifier(property.left)) {
            derefMemo(
              path,
              property.left,
              newIdentifier
            );
          } else if (t12.isArrayPattern(property.left) || t12.isObjectPattern(property.left)) {
            declarators = [...declarators, ...destructureVariable(
              state,
              path,
              t12.callExpression(newIdentifier, []),
              property.left,
              defaultIdentifier
            )];
          }
        } else if (t12.isArrayPattern(property) || t12.isObjectPattern(property)) {
          declarators = [...declarators, ...destructureVariable(
            state,
            path,
            t12.callExpression(newIdentifier, []),
            property
          )];
        } else if (t12.isRestElement(property)) {
          const trueIdentifier = unwrapNode(property.argument, t12.isIdentifier);
          if (trueIdentifier) {
            restIdentifier = trueIdentifier;
          }
        }
      }
    });
  }
  const expr = t12.variableDeclarator(
    otherIdentifier,
    properties.length ? t12.memberExpression(
      t12.callExpression(
        getImportIdentifier(state, path, "splitProps", "solid-js"),
        [
          defaultValue != null ? t12.callExpression(
            getImportIdentifier(state, path, "mergeProps", "solid-js"),
            [target, defaultValue]
          ) : target,
          t12.arrayExpression(properties)
        ]
      ),
      t12.numericLiteral(1),
      true
    ) : target
  );
  declarators.push(expr);
  if (restIdentifier) {
    const targetName = restIdentifier.name;
    const rest = restIdentifier;
    path.scope.path.traverse({
      ObjectProperty(p) {
        if (!(p.scope !== path.scope && p.scope.hasOwnBinding(targetName)) && p.node.shorthand && t12.isIdentifier(p.node.key) && p.node.key.name === targetName && t12.isIdentifier(p.node.value) && p.node.value.name === targetName) {
          p.replaceWith(
            t12.objectProperty(
              rest,
              otherIdentifier
            )
          );
        }
      },
      Expression(p) {
        if (t12.isIdentifier(p.node) && p.node.name === targetName && !(p.scope !== path.scope && p.scope.hasOwnBinding(targetName))) {
          p.replaceWith(otherIdentifier);
        }
      }
    });
  }
  return declarators;
}

// src/core/memo-variable.ts
var t13 = __toESM(require("@babel/types"), 1);
function memoVariable(state, path, memoIdentifier, stateIdentifier, optionsIdentifier) {
  const normalIdentifier = t13.arrowFunctionExpression([], stateIdentifier);
  const exprs = [normalIdentifier];
  if (state.opts.dev) {
    exprs.push(t13.identifier("undefined"));
    if (optionsIdentifier) {
      exprs.push(t13.callExpression(
        t13.memberExpression(
          t13.identifier("Object"),
          t13.identifier("assign")
        ),
        [
          t13.objectExpression([
            t13.objectProperty(
              t13.identifier("name"),
              t13.stringLiteral(memoIdentifier.name)
            )
          ]),
          optionsIdentifier
        ]
      ));
    } else {
      exprs.push(t13.objectExpression([
        t13.objectProperty(
          t13.identifier("name"),
          t13.stringLiteral(memoIdentifier.name)
        )
      ]));
    }
  } else if (optionsIdentifier) {
    exprs.push(t13.identifier("undefined"));
    exprs.push(optionsIdentifier);
  }
  return accessorVariable(
    path,
    memoIdentifier,
    getImportIdentifier(state, path, "createMemo", "solid-js"),
    exprs
  );
}

// src/core/signal-variable.ts
var t14 = __toESM(require("@babel/types"), 1);
function signalVariable(state, path, signalIdentifier, stateIdentifier, optionsIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  const callee = getImportIdentifier(state, path, "createSignal", "solid-js");
  const args = [stateIdentifier];
  if (state.opts.dev) {
    const nameOption = t14.objectExpression([
      t14.objectProperty(
        t14.identifier("name"),
        t14.stringLiteral(signalIdentifier.name)
      )
    ]);
    if (optionsIdentifier) {
      args.push(
        t14.callExpression(
          t14.memberExpression(
            t14.identifier("Object"),
            t14.identifier("assign")
          ),
          [
            nameOption,
            optionsIdentifier
          ]
        )
      );
    } else {
      args.push(nameOption);
    }
  } else if (optionsIdentifier) {
    args.push(optionsIdentifier);
  }
  derefSignal(
    path,
    signalIdentifier,
    readIdentifier,
    writeIdentifier
  );
  return t14.variableDeclarator(
    t14.arrayPattern([
      readIdentifier,
      writeIdentifier
    ]),
    t14.callExpression(callee, args)
  );
}

// src/transform-ctf.ts
var AUTO_ARROW_CTF = {
  $lazy: ["lazy", "solid-js", 1],
  $untrack: ["untrack", "solid-js", 1],
  $batch: ["batch", "solid-js", 1],
  $observable: ["observable", "solid-js", 1],
  $selector: ["createSelector", "solid-js", 1],
  $on: ["on", "solid-js", 3]
};
var AUTO_IMPORT_ALIAS_CTF = {
  $root: ["createRoot", "solid-js"],
  $useContext: ["useContext", "solid-js"],
  $createContext: ["createContext", "solid-js"],
  $uid: ["createUniqueId", "solid-js"],
  $effect: ["createEffect", "solid-js"],
  $computed: ["createComputed", "solid-js"],
  $renderEffect: ["createRenderEffect", "solid-js"],
  $merge: ["mergeProps", "solid-js"],
  $resource: ["createResource", "solid-js"],
  $cleanup: ["onCleanup", "solid-js"],
  $mount: ["onMount", "solid-js"],
  $error: ["onError", "solid-js"],
  $reaction: ["createReaction", "solid-js"],
  $startTransition: ["startTransition", "solid-js"],
  $useTransition: ["useTransition", "solid-js"],
  $owner: ["getOwner", "solid-js"],
  $runWithOwner: ["runWithOwner", "solid-js"],
  // Store API
  $store: ["createStore", "solid-js/store"],
  $mutable: ["createMutable", "solid-js/store"],
  $produce: ["produce", "solid-js/store"],
  $reconcile: ["reconcile", "solid-js/store"],
  $unwrap: ["unwrap", "solid-js/store"]
};
var AUTO_ACCESSOR_CTF = {
  $from: ["from", "solid-js", 1, true],
  $children: ["children", "solid-js", 1, false],
  $mapArray: ["mapArray", "solid-js", 3, false],
  $indexArray: ["indexArray", "solid-js", 3, false]
};
var SIGNAL_CTF = "$signal";
var MEMO_CTF = "$memo";
var DEREF_SIGNAL_CTF = "$derefSignal";
var DEREF_MEMO_CTF = "$derefMemo";
var REACTIVE_CTF = "$";
var DEFERRED_CTF = "$deferred";
var DESTRUCTURE_CTF = "$destructure";
var COMPONENT_CTF = "$component";
var SPECIAL_CTF = /* @__PURE__ */ new Set([
  SIGNAL_CTF,
  MEMO_CTF,
  DEREF_SIGNAL_CTF,
  DEREF_MEMO_CTF,
  REACTIVE_CTF,
  DEFERRED_CTF,
  DESTRUCTURE_CTF,
  COMPONENT_CTF
]);
function transformCTF(state, path) {
  path.traverse({
    CallExpression(p) {
      var _a, _b;
      const trueIdentifier = unwrapNode(p.node.callee, t15.isIdentifier);
      if (trueIdentifier && !p.scope.hasBinding(trueIdentifier.name) && !((_b = (_a = state.opts.disabled) == null ? void 0 : _a.ctf) == null ? void 0 : _b[trueIdentifier.name])) {
        if (trueIdentifier.name in AUTO_ARROW_CTF) {
          const [name, source, limit] = AUTO_ARROW_CTF[trueIdentifier.name];
          const args = p.node.arguments;
          assert(args.length <= limit, unexpectedArgumentLength(p, args.length, limit));
          const [argument, ...rest] = args;
          assert(t15.isExpression(argument), unexpectedType(p, argument.type, "Expression"));
          p.replaceWith(
            t15.callExpression(
              getImportIdentifier(state, p, name, source),
              [
                t15.isArrowFunctionExpression(argument) || t15.isFunctionExpression(argument) ? argument : t15.arrowFunctionExpression([], argument),
                ...rest
              ]
            )
          );
        }
        if (trueIdentifier.name === COMPONENT_CTF) {
          const args = p.node.arguments;
          assert(args.length === 1, unexpectedArgumentLength(p, args.length, 1));
          const argument = args[0];
          assert(t15.isFunctionExpression(argument) || t15.isArrowFunctionExpression(argument), unexpectedType(p, argument.type, "FunctionExpression | ArrowFunctionExpression"));
          if (argument.params.length > 0) {
            const params = argument.params[0];
            if (t15.isObjectPattern(params)) {
              const props = p.scope.generateUidIdentifier("props");
              argument.params[0] = props;
              const declaration = t15.variableDeclaration(
                "const",
                [
                  t15.variableDeclarator(
                    params,
                    t15.callExpression(
                      t15.identifier("$destructure"),
                      [props]
                    )
                  )
                ]
              );
              if (t15.isExpression(argument.body)) {
                argument.body = t15.blockStatement([
                  declaration,
                  t15.returnStatement(argument.body)
                ]);
              } else {
                argument.body.body.unshift(declaration);
              }
            }
          }
          p.replaceWith(argument);
        }
      }
    },
    Expression(p) {
      var _a, _b;
      if (t15.isIdentifier(p.node) && !p.scope.hasBinding(p.node.name)) {
        if (p.node.name in AUTO_IMPORT_ALIAS_CTF && !((_b = (_a = state.opts.disabled) == null ? void 0 : _a.ctf) == null ? void 0 : _b[p.node.name])) {
          const [name, source] = AUTO_IMPORT_ALIAS_CTF[p.node.name];
          p.replaceWith(getImportIdentifier(state, p, name, source));
        }
      }
    },
    VariableDeclarator(p) {
      var _a, _b;
      const { id, init } = p.node;
      if (init) {
        const trueCallExpr = unwrapNode(init, t15.isCallExpression);
        if (trueCallExpr) {
          const trueCallee = unwrapNode(trueCallExpr.callee, t15.isIdentifier);
          if (trueCallee && !p.scope.hasBinding(trueCallee.name) && (SPECIAL_CTF.has(trueCallee.name) || trueCallee.name in AUTO_ACCESSOR_CTF) && !((_b = (_a = state.opts.disabled) == null ? void 0 : _a.ctf) == null ? void 0 : _b[trueCallee.name])) {
            if (t15.isIdentifier(id)) {
              if (trueCallee.name in AUTO_ACCESSOR_CTF) {
                const [name, source, limit, arrow] = AUTO_ACCESSOR_CTF[trueCallee.name];
                const args = trueCallExpr.arguments;
                assert(args.length <= limit, unexpectedArgumentLength(p, args.length, limit));
                const [argument, ...rest] = args;
                assert(t15.isExpression(argument), unexpectedType(p, argument.type, "Expression"));
                p.replaceWith(
                  accessorVariable(
                    p,
                    id,
                    getImportIdentifier(state, p, name, source),
                    [
                      arrow ? t15.arrowFunctionExpression([], argument) : argument,
                      ...rest
                    ]
                  )
                );
              } else if (trueCallee.name === SIGNAL_CTF) {
                const args = trueCallExpr.arguments;
                assert(args.length <= 2, unexpectedArgumentLength(p, args.length, 2));
                let argument;
                let options;
                if (trueCallExpr.arguments.length > 0) {
                  const initialState = trueCallExpr.arguments[0];
                  assert(t15.isExpression(initialState), unexpectedType(p, initialState.type, "Expression"));
                  argument = initialState;
                  if (trueCallExpr.arguments.length > 1) {
                    const optionsValue = trueCallExpr.arguments[1];
                    assert(t15.isExpression(optionsValue), unexpectedType(p, optionsValue.type, "Expression"));
                    options = optionsValue;
                  }
                }
                p.replaceWith(
                  signalVariable(
                    state,
                    p,
                    id,
                    argument || t15.identifier("undefined"),
                    options
                  )
                );
              } else if (trueCallee.name === MEMO_CTF || trueCallee.name === REACTIVE_CTF) {
                const args = trueCallExpr.arguments;
                assert(args.length <= 2, unexpectedArgumentLength(p, args.length, 2));
                const argument = args[0];
                assert(t15.isExpression(argument), unexpectedType(p, argument.type, "Expression"));
                let options;
                if (args.length > 1) {
                  const optionsValue = args[1];
                  assert(t15.isExpression(optionsValue), unexpectedType(p, optionsValue.type, "Expression"));
                  options = optionsValue;
                }
                p.replaceWith(
                  memoVariable(
                    state,
                    p,
                    id,
                    argument,
                    options
                  )
                );
              } else if (trueCallee.name === DEREF_SIGNAL_CTF) {
                const args = trueCallExpr.arguments;
                assert(args.length === 1, unexpectedArgumentLength(p, args.length, 1));
                const argument = args[0];
                assert(t15.isExpression(argument), unexpectedType(p, argument.type, "Expression"));
                p.replaceWith(
                  derefSignalVariable(
                    p,
                    id,
                    argument
                  )
                );
              } else if (trueCallee.name === DEREF_MEMO_CTF) {
                const args = trueCallExpr.arguments;
                assert(args.length === 1, unexpectedArgumentLength(p, args.length, 1));
                const argument = args[0];
                assert(t15.isExpression(argument), unexpectedType(p, argument.type, "Expression"));
                p.replaceWith(
                  derefMemoVariable(
                    p,
                    id,
                    argument
                  )
                );
              } else if (trueCallee.name === DEFERRED_CTF) {
                const args = trueCallExpr.arguments;
                assert(args.length <= 2, unexpectedArgumentLength(p, args.length, 2));
                let argument;
                let options;
                if (args.length > 0) {
                  const initialState = args[0];
                  assert(t15.isExpression(initialState), unexpectedType(p, initialState.type, "Expression"));
                  argument = initialState;
                  if (args.length > 1) {
                    const optionsValue = args[1];
                    assert(t15.isExpression(optionsValue), unexpectedType(p, optionsValue.type, "Expression"));
                    options = optionsValue;
                  }
                }
                p.replaceWith(
                  deferredVariable(
                    state,
                    p,
                    id,
                    argument,
                    options
                  )
                );
              }
            } else if (trueCallee.name === DESTRUCTURE_CTF) {
              const args = trueCallExpr.arguments;
              assert(args.length === 1, unexpectedArgumentLength(p, args.length, 1));
              const argument = args[0];
              assert(t15.isExpression(argument), unexpectedType(p, argument.type, "Expression"));
              assert(t15.isObjectPattern(id) || t15.isArrayPattern(id), unexpectedType(p, id.type, "ArrayPattern | ObjectPattern"));
              p.replaceWithMultiple(
                destructureVariable(
                  state,
                  p,
                  argument,
                  id
                )
              );
            }
          }
        }
      }
    },
    ExpressionStatement(p) {
      var _a, _b;
      const trueCallExpr = unwrapNode(p.node.expression, t15.isCallExpression);
      if (trueCallExpr) {
        const trueCallee = unwrapNode(trueCallExpr.callee, t15.isIdentifier);
        if (trueCallee && !p.scope.hasBinding(trueCallee.name) && !((_b = (_a = state.opts.disabled) == null ? void 0 : _a.ctf) == null ? void 0 : _b[trueCallee.name])) {
          if (trueCallee.name === REACTIVE_CTF) {
            const args = trueCallExpr.arguments;
            assert(args.length === 1, unexpectedArgumentLength(p, args.length, 1));
            const argument = args[0];
            assert(t15.isExpression(argument), unexpectedType(p, argument.type, "Expression"));
            p.replaceWith(
              t15.expressionStatement(
                t15.callExpression(
                  getImportIdentifier(state, p, "createEffect", "solid-js"),
                  [
                    t15.arrowFunctionExpression([], argument)
                  ]
                )
              )
            );
          }
        }
      }
    }
  });
}

// src/transform-label.ts
var t16 = __toESM(require("@babel/types"), 1);
var REACTIVE_LABEL = "$";
var SPECIAL_LABELS = /* @__PURE__ */ new Set([
  REACTIVE_LABEL
]);
var VARIABLE_LABEL = {
  signal: true,
  memo: true,
  deferred: true,
  destructure: true,
  children: true
};
var CALLBACK_LABEL = {
  effect: ["createEffect", "solid-js", true],
  computed: ["createComputed", "solid-js", true],
  renderEffect: ["createRenderEffect", "solid-js", true],
  mount: ["onMount", "solid-js", false],
  cleanup: ["onCleanup", "solid-js", false],
  error: ["onError", "solid-js", false],
  root: ["createRoot", "solid-js", false],
  untrack: ["untrack", "solid-js", false],
  batch: ["untrack", "solid-js", false],
  transition: ["startTransition", "solid-js", false]
};
function transformLabels(state, path) {
  path.traverse({
    LabeledStatement(p) {
      var _a, _b;
      const labelName = p.node.label.name;
      let { body } = p.node;
      if ((SPECIAL_LABELS.has(labelName) || labelName in VARIABLE_LABEL || labelName in CALLBACK_LABEL) && !((_b = (_a = state.opts.disabled) == null ? void 0 : _a.label) == null ? void 0 : _b[labelName])) {
        if (labelName === REACTIVE_LABEL) {
          let target;
          if (t16.isExpressionStatement(body)) {
            target = body.expression;
          } else if (t16.isBlockStatement(body)) {
            target = body;
          } else {
            throw unexpectedType(p, body.type, "ExpressionStatement | BlockStatement");
          }
          p.replaceWith(
            t16.callExpression(
              getImportIdentifier(state, p, "createEffect", "solid-js"),
              [
                t16.arrowFunctionExpression(
                  [],
                  target
                )
              ]
            )
          );
        }
        if (labelName in VARIABLE_LABEL) {
          assert(t16.isVariableDeclaration(body), unexpectedType(p, p.node.type, "VariableDeclaration"));
          let declarators = [];
          forEach(body.declarations, (declarator) => {
            var _a2, _b2, _c, _d;
            switch (labelName) {
              case "signal":
                if (t16.isIdentifier(declarator.id)) {
                  declarators.push(
                    signalVariable(
                      state,
                      p,
                      declarator.id,
                      (_a2 = declarator.init) != null ? _a2 : t16.identifier("undefined")
                    )
                  );
                }
                break;
              case "memo":
                if (t16.isIdentifier(declarator.id)) {
                  declarators.push(
                    memoVariable(
                      state,
                      p,
                      declarator.id,
                      (_b2 = declarator.init) != null ? _b2 : t16.identifier("undefined")
                    )
                  );
                }
                break;
              case "deferred":
                if (t16.isIdentifier(declarator.id)) {
                  declarators.push(
                    deferredVariable(
                      state,
                      p,
                      declarator.id,
                      (_c = declarator.init) != null ? _c : t16.identifier("undefined")
                    )
                  );
                }
                break;
              case "destructure":
                if ((t16.isObjectPattern(declarator.id) || t16.isArrayPattern(declarator.id)) && declarator.init) {
                  declarators = [...declarators, ...destructureVariable(
                    state,
                    p,
                    declarator.init,
                    declarator.id
                  )];
                }
                break;
              case "children":
                if (t16.isIdentifier(declarator.id)) {
                  declarators.push(
                    accessorVariable(
                      p,
                      declarator.id,
                      getImportIdentifier(state, p, "children", "solid-js"),
                      [
                        t16.arrowFunctionExpression(
                          [],
                          (_d = declarator.init) != null ? _d : t16.identifier("undefined")
                        )
                      ]
                    )
                  );
                }
                break;
              default:
                break;
            }
          });
          p.replaceWith(
            t16.variableDeclaration(
              "const",
              declarators
            )
          );
        }
        if (labelName in CALLBACK_LABEL) {
          const [name, source, named] = CALLBACK_LABEL[labelName];
          let nameOption;
          let callback;
          if (named && t16.isLabeledStatement(body)) {
            nameOption = body.label.name;
            body = body.body;
          }
          if (t16.isBlockStatement(body)) {
            callback = t16.arrowFunctionExpression(
              [],
              body
            );
          } else if (t16.isExpressionStatement(body)) {
            callback = body.expression;
          } else {
            throw unexpectedType(p, body.type, "BlockStatement | ExpressionStatement");
          }
          const args = [callback];
          if (named && nameOption) {
            args.push(
              t16.identifier("undefined"),
              t16.objectExpression([
                t16.objectProperty(
                  t16.identifier("name"),
                  t16.stringLiteral(nameOption)
                )
              ])
            );
          }
          p.replaceWith(
            t16.callExpression(
              getImportIdentifier(state, p, name, source),
              args
            )
          );
        }
      }
    }
  });
}

// src/transform-comment.ts
var t17 = __toESM(require("@babel/types"), 1);
var VARIABLE_LABEL2 = {
  "@signal": true,
  "@memo": true,
  "@deferred": true,
  "@destructure": true,
  "@children": true
};
var CALLBACK_LABEL2 = {
  "@effect": ["createEffect", "solid-js", true],
  "@computed": ["createComputed", "solid-js", true],
  "@renderEffect": ["createRenderEffect", "solid-js", true],
  "@mount": ["onMount", "solid-js", false],
  "@cleanup": ["onCleanup", "solid-js", false],
  "@error": ["onError", "solid-js", false],
  "@root": ["createRoot", "solid-js", false],
  "@untrack": ["untrack", "solid-js", false],
  "@batch": ["untrack", "solid-js", false],
  "@transition": ["startTransition", "solid-js", false]
};
function transformComments(state, path) {
  path.traverse({
    VariableDeclaration(p) {
      const comments = p.node.leadingComments;
      if (comments) {
        let preference;
        forEach(comments, (comment) => {
          var _a, _b;
          const value = comment.value.trim();
          if (value in VARIABLE_LABEL2 && !((_b = (_a = state.opts.disabled) == null ? void 0 : _a.pragma) == null ? void 0 : _b[value])) {
            preference = value;
            comment.value = "";
          }
        });
        if (preference) {
          const { declarations } = p.node;
          let declarators = [];
          forEach(declarations, (declarator) => {
            var _a, _b, _c, _d;
            switch (preference) {
              case "@signal":
                if (t17.isIdentifier(declarator.id)) {
                  declarators.push(
                    signalVariable(
                      state,
                      p,
                      declarator.id,
                      (_a = declarator.init) != null ? _a : t17.identifier("undefined")
                    )
                  );
                }
                break;
              case "@memo":
                if (t17.isIdentifier(declarator.id)) {
                  declarators.push(
                    memoVariable(
                      state,
                      p,
                      declarator.id,
                      (_b = declarator.init) != null ? _b : t17.identifier("undefined")
                    )
                  );
                }
                break;
              case "@deferred":
                if (t17.isIdentifier(declarator.id)) {
                  declarators.push(
                    deferredVariable(
                      state,
                      p,
                      declarator.id,
                      (_c = declarator.init) != null ? _c : t17.identifier("undefined")
                    )
                  );
                }
                break;
              case "@destructure":
                if ((t17.isObjectPattern(declarator.id) || t17.isArrayPattern(declarator.id)) && declarator.init) {
                  declarators = [...declarators, ...destructureVariable(
                    state,
                    p,
                    declarator.init,
                    declarator.id
                  )];
                }
                break;
              case "@children":
                if (t17.isIdentifier(declarator.id)) {
                  declarators.push(
                    accessorVariable(
                      p,
                      declarator.id,
                      getImportIdentifier(state, p, "children", "solid-js"),
                      [
                        t17.arrowFunctionExpression(
                          [],
                          (_d = declarator.init) != null ? _d : t17.identifier("undefined")
                        )
                      ]
                    )
                  );
                }
                break;
              default:
                break;
            }
          });
          p.replaceWith(
            t17.variableDeclaration(
              "const",
              declarators
            )
          );
        }
      }
    },
    BlockStatement(p) {
      if (!t17.isBlockStatement(p.parent)) {
        return;
      }
      const comments = p.node.leadingComments;
      if (comments) {
        let preference;
        let nameOption;
        forEach(comments, (comment) => {
          var _a, _b;
          const value = comment.value.trim();
          if (/^@\w+( .*)?$/.test(value)) {
            const [tag, ...debugName] = value.split(" ");
            if (tag in CALLBACK_LABEL2 && !((_b = (_a = state.opts.disabled) == null ? void 0 : _a.pragma) == null ? void 0 : _b[value])) {
              preference = tag;
              nameOption = debugName.join(" ");
              comment.value = "";
            }
          }
        });
        if (preference) {
          const [name, source, named] = CALLBACK_LABEL2[preference];
          const callback = t17.arrowFunctionExpression(
            [],
            p.node
          );
          const args = [callback];
          if (named && nameOption) {
            args.push(
              t17.identifier("undefined"),
              t17.objectExpression([
                t17.objectProperty(
                  t17.identifier("name"),
                  t17.stringLiteral(nameOption)
                )
              ])
            );
          }
          p.replaceWith(
            t17.callExpression(
              getImportIdentifier(state, p, name, source),
              args
            )
          );
        }
      }
    },
    ExpressionStatement(p) {
      const comments = p.node.leadingComments;
      if (comments) {
        let preference;
        let nameOption;
        forEach(comments, (comment) => {
          var _a, _b;
          const value = comment.value.trim();
          if (/^@\w+( .*)?$/.test(value)) {
            const [tag, ...debugName] = value.split(" ");
            if (tag in CALLBACK_LABEL2 && !((_b = (_a = state.opts.disabled) == null ? void 0 : _a.pragma) == null ? void 0 : _b[value])) {
              preference = tag;
              nameOption = debugName.join(" ");
              comment.value = "";
            }
          }
        });
        if (preference) {
          const [name, source, named] = CALLBACK_LABEL2[preference];
          const callback = t17.arrowFunctionExpression(
            [],
            p.node.expression
          );
          const args = [callback];
          if (named && nameOption) {
            args.push(
              t17.identifier("undefined"),
              t17.objectExpression([
                t17.objectProperty(
                  t17.identifier("name"),
                  t17.stringLiteral(nameOption)
                )
              ])
            );
          }
          p.replaceWith(
            t17.callExpression(
              getImportIdentifier(state, p, name, source),
              args
            )
          );
        }
      }
    }
  });
}

// src/index.ts
function solidLabelsPlugin() {
  return {
    name: "solid-labels",
    pre() {
      this.hooks = /* @__PURE__ */ new Map();
    },
    visitor: {
      Program(path, state) {
        transformComments(state, path);
        transformLabels(state, path);
        transformCTF(state, path);
        transformComponents(state, path);
      }
    }
  };
}
//# sourceMappingURL=index.cjs.map
